/* 
 * File:   Controls.cpp
 * Author: MasterLinux
 * 
 * Created on 18. Februar 2010, 17:08
 */

#include "Controls.h"

Controls::Controls() {
    this->isExit = false;
}

Controls::Controls(const Controls& orig) {
}

Controls::~Controls() {
}

void Controls::eventHandler() {
    //listen to events
    if(SDL_PollEvent(&event)) {
        //quit if escape is pressed or the window is closed
        if(event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_ESCAPE || event.type == SDL_QUIT) {
            //exit event realize
            this->isExit = true;
        } else {
            //no event realize
            this->isExit = false;
        }

        if(event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_UP) {
            //exit event realize
            this->isUp = true;
        } else {
            //no event realize
            this->isUp = false;
        }

        if(event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_DOWN) {
            //exit event realize
            this->isDown = true;
        } else {
            //no event realize
            this->isDown = false;
        }

        if(event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_LEFT) {
            //exit event realize
            this->isLeft = true;
        } else {
            //no event realize
            this->isLeft = false;
        }

        if(event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_RIGHT) {
            //exit event realize
            this->isRight = true;
        } else {
            //no event realize
            this->isRight = false;
        }

        //mouse events
        if(event.type == SDL_MOUSEBUTTONDOWN && event.button.button == SDL_BUTTON_LEFT) {
            //exit event realize
            this->isLeftMouse = true;
            //get coordinates
            this->leftMouseX = event.button.x;
            this->leftMouseY = event.button.y;
        } else {
            //no event realize
            this->isLeftMouse = false;
        }

        if(event.type == SDL_MOUSEBUTTONDOWN && event.button.button == SDL_BUTTON_RIGHT) {
            //exit event realize
            this->isRightMouse = true;
            //get coordinates
            this->rightMouseX = event.button.x;
            this->rightMouseY = event.button.y;
        } else {
            //no event realize
            this->isRightMouse = false;
        }
    }
}

bool Controls::exit() {
    return this->isExit;
}

bool Controls::up() {
    return this->isUp;
}

bool Controls::down() {
    return this->isDown;
}

bool Controls::right() {
    return this->isRight;
}

bool Controls::left() {   
    return this->isLeft;
}

bool Controls::leftMouse(int *x, int *y) {
    //return coords
    *x = this->leftMouseX;
    *y = this->leftMouseY;

    return this->isLeftMouse;
}
bool Controls::rightMouse(int *x, int *y){
    //return coords
    *x = this->rightMouseX;
    *y = this->rightMouseY;

    return this->isRightMouse;
}
void Controls::mousePosition(int *x, int *y){
    //get absolute mouse position
    SDL_GetMouseState(x, y);
}

