/* 
 * File:   Controls.h
 * Author: MasterLinux
 *
 * Created on 18. Februar 2010, 17:08
 */

#ifndef _CONTROLS_H
#define	_CONTROLS_H

#include "SDL.h"

class Controls {
public:
    Controls();
    Controls(const Controls& orig);
    virtual ~Controls();

    void eventHandler();

    /*
     * listen to an input event
     * and returns true if escape is pressed
     * or a SDL_QUIT event is realized
     * otherwise it returns false
     */
    bool exit();

    bool up();
    bool down();
    bool right();
    bool left();
    
    //mouse events
    bool leftMouse(int *x, int *y);
    bool rightMouse(int *x, int *y);
    void mousePosition(int *x, int *y);

    
private:
    SDL_Event event;
    //key info
    bool isExit, isUp, isDown, isLeft, isRight;

    //mouse info
    bool isLeftMouse, isRightMouse;
    int leftMouseX, leftMouseY;
    int rightMouseX, rightMouseY;
    int mousePositionX, mousePositionY;

};

#endif	/* _CONTROLS_H */

