/* 
 * File:   Engine.cpp
 * Author: MasterLinux
 * 
 * Created on 18. Februar 2010, 16:23
 */

#include "Engine.h"

Engine::Engine() {
}

Engine::Engine(const Engine& orig) {
}

Engine::~Engine() {
    //unload surfaces
    delete this->screen;
}

void Engine::window(int _width, int _height, const char *title) {
    this->screenWidth = _width;
    this->screenHeight = _height;

    this->screen = new Window(_width, _height);
}

SDL_Surface* Engine::windowSurface() {
    return this->screen->getWindow();
}

void Engine::refresh() {
    this->screen->refresh();
}

void Engine::draw(Image* image) {
    int x, y;
    image->getPosition(&x, &y);
    this->draw(image->getImage(), x, y);
}

void Engine::draw(AnimatedImage *image) {
    int x, y;
    image->getPosition(&x, &y);
    //image->setStartFrame(startFrame);
    this->draw(image->getImage(), x, y);
}

void Engine::draw(SDL_Surface *image, int x, int y) {
    SDL_Rect clipping;
    clipping.y = y;
    clipping.x = x;

    //load image onto screen
    SDL_BlitSurface(image, NULL, this->windowSurface(), &clipping);

    //update screen
    SDL_Flip(this->windowSurface());
}

void Engine::createSurface(SDL_Surface *output, SDL_Surface *input, SDL_Rect position) {
    //load image onto screen
    SDL_BlitSurface(input, NULL, output, &position);
}

int Engine::width() {
    return this->screenWidth;
}

int Engine::height() {
    return this->screenHeight;
}


