/* 
 * File:   Engine.h
 * Author: MasterLinux
 *
 * Created on 18. Februar 2010, 16:23
 */

#ifndef _ENGINE_H
#define	_ENGINE_H

#include "SDL.h"
#include "Window.h"
#include "Image.h"
#include "AnimatedImage.h"


using namespace std;

class Engine {
public:
    Engine();
    Engine(const Engine& orig);
    virtual ~Engine();

    void window(int _width, int _height, const char *title);
    SDL_Surface* windowSurface();
    

    void draw(Image *image);
    void draw(AnimatedImage *image); 
    void draw(SDL_Surface *image, int x, int y);
    void refresh();

    void createSurface(SDL_Surface *output, SDL_Surface *input, SDL_Rect position);
    int width();
    int height();
    
private:
    int screenWidth, screenHeight;
    Window *screen;

};

#endif	/* _ENGINE_H */

