/* 
 * File:   main.cpp
 * Author: MasterLinux
 *
 * Created on 18. Februar 2010, 15:08
 */

#include "SDL.h"
#include "Engine.h"
#include "Controls.h"
#include "Image.h"
#include "AnimatedImage.h"

/*
 * 
 */
int main(int argc, char** argv) {


    AnimatedImage *aimg = new AnimatedImage();

    aimg->setPosition(60, 120);
    
    aimg->addToQuene("content/test/tilesCounter1.tga");
    aimg->addToQuene("content/test/tilesCounter2.tga");
    aimg->addToQuene("content/test/tilesCounter3.tga");
    aimg->addToQuene("content/test/tilesCounter4.tga");
    aimg->addToQuene("content/test/tilesCounter5.tga");
    aimg->addToQuene("content/test/tilesCounter6.tga");
    aimg->addToQuene("content/test/tilesCounter7.tga");
    aimg->addToQuene("content/test/tilesCounter8.tga");
    aimg->addToQuene("content/test/tilesCounter9.tga");
    aimg->setAnimationTime(9000);
    aimg->shuffle(true);
    
    Engine *engine = new Engine();
    Controls *controls = new Controls();

    int x, y;
    
    //init window
    engine->window(800, 480, "echtma");

    while(!controls->exit()) {       
        controls->eventHandler();

        engine->refresh();
        engine->draw(aimg);
        
        if(controls->up())      aimg->start();//y = landscape->moveCameraY(--y);
        if(controls->down())    aimg->stop();//y = landscape->moveCameraY(++y);
        if(controls->right())   aimg->pause(true);//x = landscape->moveCameraX(++x);
        if(controls->left())    aimg->pause(false);//x = landscape->moveCameraX(--x);
        if(controls->leftMouse(&x, &y)) aimg->setPosition(x, y);

        controls->mousePosition(&x, &y);
        aimg->setPosition(x, y);
    }

    delete aimg;
    //quit sdl

    SDL_Quit();
    
    
    return 0;
}

